"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _reactNative = require("react-native");

var _expo = require("expo");

var _expo2 = _interopRequireDefault(_expo);

var _glReact = require("gl-react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function hash(obj) {
  return JSON.stringify(obj); // FIXME ikr XD
}

var ExponentGLObjectTextureLoader = function (_TextureLoader) {
  _inherits(ExponentGLObjectTextureLoader, _TextureLoader);

  function ExponentGLObjectTextureLoader() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ExponentGLObjectTextureLoader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ExponentGLObjectTextureLoader.__proto__ || Object.getPrototypeOf(ExponentGLObjectTextureLoader)).call.apply(_ref, [this].concat(args))), _this), _this.loads = new Map(), _this.textures = new Map(), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ExponentGLObjectTextureLoader, [{
    key: "dispose",
    value: function dispose() {}
  }, {
    key: "canLoad",
    value: function canLoad(input) {
      if (!_reactNative.NativeModules.ExponentGLObjectManager || !_reactNative.NativeModules.ExponentGLObjectManager.createObjectAsync) {
        return false;
      }
      return input && (typeof input === "undefined" ? "undefined" : _typeof(input)) === "object" && input.camera;
    }
  }, {
    key: "load",
    value: function load(texture) {
      var _this2 = this;

      var key = hash(texture);
      var load = this.loads.get(key);
      if (load) return load;
      var gl = this.gl;
      // $FlowFixMe

      var exglCtxId = gl.__exglCtxId;

      var disposed = false;
      var d = {
        dispose: function dispose() {
          disposed = true;
        },
        promise: _reactNative.NativeModules.ExponentGLObjectManager.createObjectAsync({
          exglCtxId: exglCtxId,
          texture: texture
        }).then(function (_ref2) {
          var exglObjId = _ref2.exglObjId;

          if (disposed) return;
          var webglTexture = new WebGLTexture(exglObjId);
          _this2.textures.set(key, webglTexture);
          return webglTexture;
        })
      };
      this.loads.set(key, d);
      return d;
    }
  }, {
    key: "get",
    value: function get(texture) {
      return this.textures.get(hash(texture));
    }
  }, {
    key: "getSize",
    value: function getSize(texture) {
      return null; // FIXME there is currently no way to yield that ( related https://github.com/gre/gl-react/issues/131)
    }
  }]);

  return ExponentGLObjectTextureLoader;
}(_glReact.TextureLoader);

exports.default = ExponentGLObjectTextureLoader;
//# sourceMappingURL=ExponentGLObjectTextureLoader.js.map