"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadAsset = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _reactNative = require("react-native");

var _expo = require("expo");

var _expo2 = _interopRequireDefault(_expo);

var _glReact = require("gl-react");

var _md = require("./md5");

var _md2 = _interopRequireDefault(_md);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var hash = function hash(module) {
  return typeof module === "number" ? module : module.uri;
};

var localAsset = function localAsset(module) {
  var asset = _expo2.default.Asset.fromModule(module);
  return asset.downloadAsync().then(function () {
    return asset;
  });
};

var remoteAssetCache = {};

var remoteAsset = function remoteAsset(uri) {
  var i = uri.lastIndexOf(".");
  var ext = i !== -1 ? uri.slice(i) : ".jpg";
  var key = (0, _md2.default)(uri);
  if (key in remoteAssetCache) {
    return Promise.resolve(remoteAssetCache[key]);
  }
  var promise = Promise.all([new Promise(function (success, failure) {
    return _reactNative.Image.getSize(uri, function (width, height) {
      return success({ width: width, height: height });
    }, failure);
  }), _reactNative.NativeModules.ExponentFileSystem.downloadAsync(uri, "ExponentAsset-" + key + ext, {
    cache: true
  })]).then(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        size = _ref2[0],
        asset = _ref2[1];

    return _extends({}, size, { uri: uri, localUri: asset.uri });
  });
  remoteAssetCache[key] = promise;
  return promise;
};

var loadAsset = exports.loadAsset = function loadAsset(module) {
  return typeof module === "number" ? localAsset(module) : remoteAsset(module.uri);
};

var ExponentTextureLoader = function (_TextureLoader) {
  _inherits(ExponentTextureLoader, _TextureLoader);

  function ExponentTextureLoader() {
    var _ref3;

    var _temp, _this, _ret;

    _classCallCheck(this, ExponentTextureLoader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref3 = ExponentTextureLoader.__proto__ || Object.getPrototypeOf(ExponentTextureLoader)).call.apply(_ref3, [this].concat(args))), _this), _this.loads = new Map(), _this.textures = new Map(), _this.assetSizes = new Map(), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ExponentTextureLoader, [{
    key: "dispose",
    value: function dispose() {
      var loads = this.loads;

      loads.forEach(function (d) {
        d.dispose();
      });
      loads.clear();
    }
  }, {
    key: "canLoad",
    value: function canLoad(input) {
      return typeof input === "number" || input && (typeof input === "undefined" ? "undefined" : _typeof(input)) === "object" && typeof input.uri === "string";
    }
  }, {
    key: "load",
    value: function load(module) {
      var _this2 = this;

      var key = hash(module);
      if (this.loads.has(key)) {
        return this.loads.get(key);
      }
      var dispose = function dispose() {};
      var ignored = false;
      var promise = loadAsset(module).then(function (asset) {
        if (ignored) return;
        var gl = _this2.gl;
        var width = asset.width,
            height = asset.height;

        var texture = gl.createTexture();
        gl.bindTexture(gl.TEXTURE_2D, texture);
        gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, width, height, 0, gl.RGBA, gl.UNSIGNED_BYTE, asset);
        _this2.textures.set(key, texture);
        _this2.assetSizes.set(key, [width, height]);
        _this2.loads.delete(key);
        return texture;
      });
      var d = {
        dispose: function dispose() {
          ignored = true;
        },

        promise: promise
      };
      this.loads.set(key, d);
      return d;
    }
  }, {
    key: "get",
    value: function get(module) {
      return this.textures.get(hash(module));
    }
  }, {
    key: "getSize",
    value: function getSize(texture) {
      return this.assetSizes.get(hash(module));
    }
  }]);

  return ExponentTextureLoader;
}(_glReact.TextureLoader);

exports.default = ExponentTextureLoader;
//# sourceMappingURL=ExponentTextureLoader.js.map